import { NavBar } from "$components/features/nav/NavBar";
import { checkpoints } from "$server/auth/accessControl";
import getUserFromCookies from "$server/auth/auth";
import type { User } from "@prisma/client";
import { GetServerSideProps } from "next";
import Head from "next/head";
import Link from "next/link";

export const getServerSideProps: GetServerSideProps = async ({ req }) => {
  const user = await getUserFromCookies(req.cookies);
  console.log(
    `${user?.firstname} ${user?.lastname} can edit regions`,
    await checkpoints({ user, permissions: ["region_edit"], context: "root" })
  );
  return {
    props: {
      user,
    },
  };
};

export default function Home({ user }: { user: User | null | undefined }) {
  return (
    <>
      <Head>
        <title>StudyForge Next.js App</title>
        <meta name="description" content="Generated by create-t3-app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <NavBar />
      <main className="flex min-h-screen flex-col items-center justify-center bg-white">
        <div className="container flex flex-col items-center justify-center gap-12 px-4 py-16">
          <h1 className="text-5xl font-extralight tracking-wide sm:text-[4rem]">
            <span className="bg-gradient-to-r from-orange-400 to-amber-300 bg-clip-text text-transparent">
              StudyForge
            </span>{" "}
            Next.js App
          </h1>
        </div>
        <div className="flex max-w-6xl flex-col items-center justify-center gap-4">
          <p>
            {user
              ? `Logged in as ${user.firstname} ${user.lastname} (id: ${user.id})`
              : `Not logged in`}
          </p>
          <p>This project uses this tech stack:</p>
          <ul className="list-disc">
            <li>Next.js</li>
            <li>Typescript</li>
            <li>Prisma</li>
            <li>tRPC</li>
            <li>Tailwind</li>
            <li>React Hook Form</li>
          </ul>
          <p>
            <Link href="/manage/regions" className="underline">
              Click here
            </Link>{" "}
            to see the demo of managing regions
          </p>
        </div>
      </main>
    </>
  );
}
